## mingw-w64-qt6-grpc-6.10.0-1.src.tar.zst

=== CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)

include(.cmake.conf)
project(QtGrpc
    VERSION "${QT_REPO_MODULE_VERSION}"
    DESCRIPTION "Qt GRPC and Protobuf generator and bindings."
    HOMEPAGE_URL "https://qt.io"
    LANGUAGES CXX C
)

set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE)

find_package(Qt6 ${PROJECT_VERSION} CONFIG REQUIRED COMPONENTS BuildInternals)

# This should be called as early as possible, just after find_package(BuildInternals) where it is
# defined.
qt_internal_project_setup()

find_package(Qt6 ${PROJECT_VERSION} CONFIG REQUIRED Core)

# Try to find Qt6::qtprotobufgen and Qt6::qtgrpcgen targets from host tools
# when cross-compiling.
if(NOT "${QT_HOST_PATH}" STREQUAL "")
    add_subdirectory("${CMAKE_CURRENT_LIST_DIR}/src/tools/host")
endif()

find_package(Qt6 ${PROJECT_VERSION} CONFIG OPTIONAL_COMPONENTS Network Gui Widgets Quick
    QmlNetwork QuickControls2 QuickTest)

include("${CMAKE_CURRENT_LIST_DIR}/src/tools/qtprotobufgen/Qt6ProtobufToolsMacros.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/src/tools/qtgrpcgen/Qt6GrpcToolsMacros.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/src/protobuf/Qt6ProtobufBuildInternals.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/src/wellknown/Qt6ProtobufWellKnownTypesBuildInternals.cmake")

qt_build_repo()

=== examples/protobuf/sensors/emulator/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.16)

qt_add_executable(protobuf_sensor_emulator
    main.cpp
    sensoremulator.h sensoremulator.cpp
    emulatorconsole.h emulatorconsole.cpp
    emulatorconsole.ui
)

target_link_libraries(protobuf_sensor_emulator PRIVATE
    Qt6::Core
    Qt6::Protobuf
    Qt6::Widgets
    Qt6::Network
    protobuf_sensors
)

install(TARGETS protobuf_sensor_emulator
    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
)

=== tests/auto/grpc/client/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause
add_subdirectory(shared)

add_subdirectory(deadline)
add_subdirectory(unarycall)
add_subdirectory(serverstream)
add_subdirectory(clientstream)
add_subdirectory(bidistream)
if(QT_FEATURE_ssl AND NOT WIN32)
    add_subdirectory(ssl)
endif()

=== tests/auto/grpc/qgrpccalloptions/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_qgrpccalloptions LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_test(tst_qgrpccalloptions
    SOURCES
        tst_qgrpccalloptions.cpp
    INCLUDE_DIRECTORIES
        "${CMAKE_CURRENT_LIST_DIR}/../shared"
    LIBRARIES
        Qt::Core
        Qt::Test
        Qt::Grpc
)

=== tests/auto/protobuf/basic/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_protobuf_basic LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt6_add_protobuf(tst_protobuf_basictypes_gen
    PROTO_FILES
        proto/basicmessages.proto
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated"
)
qt_autogen_tools_initial_setup(tst_protobuf_basictypes_gen)

qt_internal_add_test(tst_protobuf_basictypes
    SOURCES
        tst_protobuf_basictypes.cpp
    INCLUDE_DIRECTORIES
        ../shared
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        tst_protobuf_basictypes_gen
)

qt6_add_protobuf(tst_protobuf_repeatedtypes_gen
    PROTO_FILES
        proto/repeatedmessages.proto
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated"
)
qt_autogen_tools_initial_setup(tst_protobuf_repeatedtypes_gen)

# @todo: this explicit linking is needed, try to make it automatic since it's a dependency
# between the proto files. In the future!
target_link_libraries(tst_protobuf_repeatedtypes_gen
    PUBLIC
        tst_protobuf_basictypes_gen
)

qt_internal_add_test(tst_protobuf_repeatedtypes
    SOURCES
        tst_protobuf_repeatedtypes.cpp
    INCLUDE_DIRECTORIES
        ../shared
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        tst_protobuf_basictypes_gen
        tst_protobuf_repeatedtypes_gen
)

qt6_add_protobuf(tst_protobuf_maptypes_gen
    PROTO_FILES
        proto/mapmessages.proto
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated"
)
if(MINGW)
    target_compile_options(tst_protobuf_maptypes_gen PRIVATE "-Wa,-mbig-obj")
endif()

qt_autogen_tools_initial_setup(tst_protobuf_maptypes_gen)

# @todo: this explicit linking is needed, try to make it automatic since it's a dependency
# between the proto files.
target_link_libraries(tst_protobuf_maptypes_gen
    PUBLIC
        tst_protobuf_basictypes_gen
)

qt_internal_add_test(tst_protobuf_maptypes
    SOURCES
        tst_protobuf_maptypes.cpp
    INCLUDE_DIRECTORIES
        ../shared
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        tst_protobuf_basictypes_gen
        tst_protobuf_maptypes_gen
)

qt6_add_protobuf(tst_protobuf_fieldindexrange_gen
    PROTO_FILES
        proto/fieldindexrange.proto
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated"
)
qt_autogen_tools_initial_setup(tst_protobuf_fieldindexrange_gen)

qt_internal_add_test(tst_protobuf_serialization_basictypes
    SOURCES
        tst_protobuf_serialization_basictypes.cpp
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        tst_protobuf_basictypes_gen
        tst_protobuf_fieldindexrange_gen
)

qt_internal_add_test(tst_protobuf_serialization_repeatedtypes
    SOURCES
        tst_protobuf_serialization_repeatedtypes.cpp
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        tst_protobuf_basictypes_gen
        tst_protobuf_repeatedtypes_gen
)

qt_internal_add_test(tst_protobuf_serialization_maptypes
    SOURCES
        tst_protobuf_serialization_maptypes.cpp
    INCLUDE_DIRECTORIES
        ../shared
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        tst_protobuf_basictypes_gen
        tst_protobuf_maptypes_gen
)

qt_internal_add_test(tst_protobuf_serialization_complex_maptypes
    SOURCES
        tst_protobuf_serialization_complex_maptypes.cpp
    INCLUDE_DIRECTORIES
        ../shared
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        tst_protobuf_basictypes_gen
        tst_protobuf_maptypes_gen
)


qt_internal_add_test(tst_protobuf_deserialization_basictypes
    SOURCES
        tst_protobuf_deserialization_basictypes.cpp
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        tst_protobuf_basictypes_gen
        tst_protobuf_fieldindexrange_gen
)

qt_internal_add_test(tst_protobuf_deserialization_repeatedtypes
    SOURCES
        tst_protobuf_deserialization_repeatedtypes.cpp
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        tst_protobuf_basictypes_gen
        tst_protobuf_repeatedtypes_gen
)

qt_internal_add_test(tst_protobuf_deserialization_maptypes
    SOURCES
        tst_protobuf_deserialization_maptypes.cpp
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        tst_protobuf_basictypes_gen
        tst_protobuf_maptypes_gen
)

qt_internal_add_test(tst_protobuf_deserialization_complex_maptypes
    SOURCES
        tst_protobuf_deserialization_complex_maptypes.cpp
    LIBRARIES
        Qt::Test
        Qt::Protobuf
        tst_protobuf_basictypes_gen
        tst_protobuf_maptypes_gen
)

qt_internal_add_test(tst_protobuf_non_packed_repeatedtypes
    SOURCES
        tst_protobuf_non_packed_repeatedtypes.cpp
    LIBRARIES
        Qt::Test
        Qt::CorePrivate
        Qt::Protobuf
)
qt6_add_protobuf(tst_protobuf_non_packed_repeatedtypes
    PROTO_FILES
        proto/repeatednonpackedmessages.proto
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated"
)
qt_autogen_tools_initial_setup(tst_protobuf_non_packed_repeatedtypes)

qt_internal_add_test(tst_protobuf_unknown_field
    SOURCES
        tst_protobuf_unknown_field.cpp
    LIBRARIES
        Qt::Test
        Qt::Protobuf)

qt6_add_protobuf(tst_protobuf_unknown_field
    PROTO_FILES
        proto/unknownfield.proto
    OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/qt_protobuf_generated"
)

qt_internal_add_test(tst_protobuf_raw_serializers
    SOURCES
        tst_protobuf_raw_serializers.cpp
    LIBRARIES
        Qt::Test
        Qt::ProtobufPrivate
        tst_protobuf_basictypes_gen
)

if(UNIX AND NOT CMAKE_CROSSCOMPILING)
    qt_internal_add_test(tst_protobuf_internals
        SOURCES
            tst_protobuf_internals.cpp
        LIBRARIES
            Qt::Test
            Qt::Protobuf
            tst_protobuf_basictypes_gen
    )
endif()

=== tests/auto/grpcquick/client/unarycall/CMakeLists.txt ===
# Copyright (C) 2023 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_grpc_client_unarycall_qml LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
    include("../../../grpc/client/shared/test_server/CMakeLists.txt")
endif()

if(NOT TARGET grpc_testserver)
    return()
endif()
qt_policy(SET QTP0001 NEW)
qt_policy(SET QTP0004 NEW)

qt_internal_add_test(tst_grpc_client_unarycall_qml
    QMLTEST
    SOURCES
        tst_grpc_client_unarycall_qml.cpp
    INCLUDE_DIRECTORIES
        ${CMAKE_CURRENT_SOURCE_DIR}/../../../grpc/shared
    DEFINES
        TEST_GRPC_SERVER_PATH="$<TARGET_FILE:grpc_testserver>"
    LIBRARIES
        Qt::Qml
        Qt::Grpc
)

qt_add_grpc(tst_grpc_client_unarycall_qml_gen CLIENT
    PROTO_FILES
        ../../../grpc/shared/proto/testservice.proto
    QML
    OUTPUT_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}/qt_grpc_generated_qml"
)

qt_add_protobuf(tst_grpc_client_unarycall_qml_gen
    PROTO_FILES
        ../../../grpc/shared/proto/testservice.proto
    QML
    QML_URI qtgrpc.tests
    OUTPUT_DIRECTORY
        "${CMAKE_CURRENT_BINARY_DIR}/qt_grpc_generated_qml"
)

qt_add_qml_module(tst_grpc_client_unarycall_qml
    URI QmlTestUri
    VERSION 1.0
    QML_FILES
        qml/tst_grpc_client_unarycall.qml
)

target_link_libraries(tst_grpc_client_unarycall_qml
    PRIVATE tst_grpc_client_unarycall_qml_gen)

add_dependencies(tst_grpc_client_unarycall_qml grpc_testserver)

qt_autogen_tools_initial_setup(tst_grpc_client_unarycall_qml)
qt_autogen_tools_initial_setup(tst_grpc_client_unarycall_qml_gen)
qt_autogen_tools_initial_setup(tst_grpc_client_unarycall_qml_genplugin)

if(QT_BUILD_STANDALONE_TESTS)
    qt_import_qml_plugins(tst_grpc_client_unarycall_qml)
    qt_import_qml_plugins(tst_grpc_client_unarycall_qml_gen)
endif()

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-grpc
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
_qtver=6.10.0
pkgver=${_qtver/-/}
pkgrel=1
pkgdesc='Qt gRPC and Protobuf generator and bindings. (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtgrpc.git"
msys2_references=(
  'archlinux: qt6-grpc'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:LGPL-3.0-only WITH Qt-GPL-exception-1.0 AND BSD-3-Clause AND GFDL-1.3-no-invariants-only AND GPL-2.0-only AND GPL-3.0-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-grpc"
             "${MINGW_PACKAGE_PREFIX}-protobuf"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz")
sha256sums=('fb722289066101ae08865378e7fb29a22b416a71f6b1c19ae5a957f53a91a445')

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-grpc() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base"
           "${MINGW_PACKAGE_PREFIX}-abseil-cpp"
           "${MINGW_PACKAGE_PREFIX}-grpc"
           "${MINGW_PACKAGE_PREFIX}-protobuf"
           "${MINGW_PACKAGE_PREFIX}-libwinpthread")
  optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-declarative")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs "${pkgdir}"/.${MINGW_PREFIX} "${srcdir}"/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
}

package_qt6-grpc-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf "${srcdir}"/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
